package org.example;

import org.springframework.boot.ApplicationRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.context.annotation.Bean;
import org.springframework.pulsar.annotation.PulsarListener;
import org.springframework.pulsar.core.PulsarTemplate;

@SpringBootApplication
public class Main {
    public static void main(String[] args) {
        SpringApplication.run(Main.class, args);
    }

    @Bean
    ApplicationRunner runner(PulsarTemplate<User> pulsarTemplate) {
        return (args) -> pulsarTemplate.send("hello-user-topic", new User("Hello User", 1));
    }

    @Bean
    ApplicationRunner runner1(PulsarTemplate<String> pulsarTemplate) {
        return (args) -> pulsarTemplate.send("hello-pulsar-topic", "Hello Pulsar World!");
    }


    @PulsarListener
    void listen(User message) {
        System.out.println("Message Received: " + message);
    }

/*
    @PulsarListener(subscriptionName = "hello-pulsar-subscription", topics = "hello-pulsar-topic")
    public void listen(String message) {
        System.out.println("Message Received: " + message);
    }
*/

/*
    @PulsarListener(subscriptionName = "my-subscription", topics = "hello-pulsar-topic")
    public void listen(org.apache.pulsar.client.api.Message<String> message) {
        System.out.println(message.getValue());
    }
*/

    @Bean
    ApplicationRunner runner2(PulsarTemplate<String> pulsarTemplate) {
        return (args) -> pulsarTemplate.send("topic-with-dlp", "Hello Pulsar World!");
    }


}

